VERSION 5.00
Begin VB.Form frmOpen 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Open file without Comdlg32.ocx"
   ClientHeight    =   1236
   ClientLeft      =   36
   ClientTop       =   324
   ClientWidth     =   3744
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1236
   ScaleWidth      =   3744
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   252
      Left            =   2640
      TabIndex        =   2
      Top             =   840
      Width           =   972
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "Open File"
      Height          =   252
      Left            =   1560
      TabIndex        =   1
      Top             =   840
      Width           =   972
   End
   Begin VB.TextBox Text1 
      Height          =   288
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   3492
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "File name:"
      Height          =   252
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   1932
   End
End
Attribute VB_Name = "frmOpen"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' code modified from original code found as vbSquare

Dim rvFileName As String ' // returned file name
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long

' // Type declarations
Private Type OPENFILENAME
  lStructSize As Long
  hwndOwner As Long
  hInstance As Long
  lpstrFilter As String
  lpstrCustomFilter As String
  nMaxCustFilter As Long
  nFilterIndex As Long
  lpstrFile As String
  nMaxFile As Long
  lpstrFileTitle As String
  nMaxFileTitle As Long
  lpstrInitialDir As String
  lpstrTitle As String
  flags As Long
  nFileOffset As Integer
  nFileExtension As Integer
  lpstrDefExt As String
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type


Private Sub cmdExit_Click()
   End
End Sub

Private Sub cmdOpen_Click()
    ' // call the open Procedure
    rvFileName$ = Open_File(frmOpen.hWnd)
    
    ' // Check the return value
    If rvFileName$ <> "" Then
       Text1 = rvFileName$
    Else
       Text1 = "Cancel"
    End If
    
End Sub


' // keep this function tucked away in a module or class file
' // or not... depending on your style.

Private Function Open_File(hWnd As Long) As String
   '
   Dim OpenFileDialog As OPENFILENAME
   Dim rv As Long
   
   ' // init dialog
   With OpenFileDialog
     .lStructSize = Len(OpenFileDialog)
     .hwndOwner = hWnd&
     .hInstance = App.hInstance
     .lpstrFilter = "Text Files (*.txt)" + Chr$(0) + "*.txt" + _
      Chr$(0) + "All Files (*.*)" + Chr$(0) + "*.*" + Chr$(0)
     .lpstrFile = Space$(254)
     .nMaxFile = 255
     .lpstrFileTitle = Space$(254)
     .nMaxFileTitle = 255
     .lpstrInitialDir = CurDir
     .lpstrTitle = "Open File..."
     .flags = 0
   End With
  
   ' // call API to show the dialog that was just initialized
   rv& = GetOpenFileName(OpenFileDialog)
   
   If (rv&) Then
      Open_File = Trim$(OpenFileDialog.lpstrFile)
   Else
      Open_File = ""
   End If
   
End Function
